package com.bonait.bnframework.common.constant;

import android.app.Activity;
import android.content.Intent;
import android.widget.LinearLayout;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_ALERTLOG;
import com.bonait.bnframework.common.db.mode.BPA_GOODPROPERTY;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_LOG;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.db.mode.BPA_SILOS;
import com.bonait.bnframework.common.db.mode.BPA_SUBORDER;
import com.bonait.bnframework.common.db.mode.BPA_SUGAR;
import com.bonait.bnframework.common.db.res.MakeStatus;
import com.bonait.bnframework.common.db.res.ResGoodProperty;
import com.bonait.bnframework.common.db.res.ResGoodsMake;
import com.bonait.bnframework.common.db.res.ResGoodsRecipe;
import com.bonait.bnframework.common.db.res.Res_PLCADDRESS1;
import com.bonait.bnframework.common.db.res.SilosLsjyMode;
import com.bonait.bnframework.common.db.res.StatusMode;
import com.bonait.bnframework.common.db.res.UserLogEnum;
import com.bonait.bnframework.common.db.res.lcMode;
import com.bonait.bnframework.common.db.res.wdszMode;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.helper.MessageLog;
import com.bonait.bnframework.common.helper.mode.OrderA;
import com.bonait.bnframework.common.helper.mode.ResultA;
import com.bonait.bnframework.modules.home.adapter.loadinggood_adapter;
import com.bonait.bnframework.modules.home.adapter.lsjy_adapter;
import com.bonait.bnframework.modules.home.adapter.pfsx_adapter;
import com.bonait.bnframework.modules.home.adapter.wdsz_adapter;
import com.bonait.bnframework.modules.home.adapter.zdqxchid_adapter;
import com.bonait.bnframework.modules.home.fragment.mode.sdkz_control;
import com.bonait.bnframework.modules.home.fragment.mode.tab_control;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 单例模式
 * 数据中心
 */
public class DataBus {
    //region 单例模式
    private static DataBus  mInstance; //实例变量设置私有，防止直接通过类名访问

    private DataBus() {
        //默认构造函数私有，防止类外直接new创建对象
    }

    public static synchronized DataBus getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance==null) {
            mInstance = new DataBus();
        }
        return mInstance;
    }
    //endregion

    //region 跳转页面

    //endregion

    //region 数据中心

    /**
     * 获取料仓数据
     * @return
     */
    public ArrayList<lcMode> ResGetLc()
    {
        ArrayList<lcMode> lc=new ArrayList<>();
        try {
            //获取料仓数据
            ArrayList<BPA_SILOS> bpa_silos = QueryDB.GetSilosALL();
            //加载materials数据
            if (bpa_silos.size() > 0) {
                for (BPA_SILOS silo : bpa_silos) {
                    List<BPA_MATERIAL> m = QueryDB.GetMaterialBySilosID(silo.id);
                    if (m.size() > 0) {
                        lc.add(new lcMode(silo.id, silo.num, m.get(0).name, silo.silosmargin, silo.siloszl, m.get(0).id,m.get(0).type, silo.warningValue, silo.thrsoleValue,silo.name.isEmpty()?"":silo.name));
                    } else {
                        lc.add(new lcMode(silo.id, silo.num, "未设置", silo.silosmargin, silo.siloszl, "",0, silo.warningValue, silo.thrsoleValue,silo.name.isEmpty()?"":silo.name));
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return lc;
    }


    /**
     * 商品制作列表
     */
    public ArrayList<ResGoodsMake> GoodsMake = new ArrayList<ResGoodsMake>();

    public loadinggood_adapter loadinggoodAdapter=null;
    public void GetTodayNoMake()
    {
        GoodsMake.clear();
        ArrayList<BPA_SUBORDER> suborders=  QueryDB.GetSubOrdersTodayNoMake();
        for (BPA_SUBORDER item:suborders)
        {
            AddGoodsMake(item);
        }

        ExecuteTheRecipe.MakeGoodCount= QueryDB.GetSuOrderTodanCount();
    }

    /**
     * 增加一个订单商品
     * @param suborder
     */
    public void AddGoodsMake(BPA_SUBORDER suborder)
    {
        try
        {
            ExecuteTheRecipe.MakeGoodCount++;
            ArrayList<String> suorderlist=new ArrayList<>();
            for (ResGoodsMake item:GoodsMake)
            {
                if(item.makeStatus==MakeStatus.制作完成)
                {
                    suorderlist.add(item.subOrder.id);
                }
            }
            for (String item:suorderlist)
            {
                DeleteGoodsMake(item);
            }

            ResGoodsMake make=new ResGoodsMake();
            make.recipes=QueryDB.GetGoodsSreciperecipeList(suborder.recipeID);
            make.good=QueryDB.GetGoodsId(suborder.goodsID);
            make.goodsrecipename=QueryDB.GetGoodsRecipeNameId(suborder.recipeID);

            if (!ConfigName.getInstance().versionSelectionEnum.equals("配料吧台"))
            {
                make.Gt1=false;
                make.Gt2=false;
                for (ResGoodsRecipe recipe:make.recipes)
                {
                    BPA_SILOS silos = null;
                    List<BPA_SILOS> siloslist = QueryDB.GetSolisByMaterialID(recipe.materialID);
                    for (BPA_SILOS item : siloslist) {
                        if(silos==null)
                            silos = item;
                    }

                    if(silos!=null && silos.num==11)
                    {
                        make.Gt1=true;
                    }else if(silos!=null && silos.num==12)
                    {
                        make.Gt2=true;
                    }
                }
            }else
            {
                make.Gt1=false;
                make.Gt2=false;
            }

            make.subOrder=suborder;
            make.makeStatus= MakeStatus.等待制作;
            make.makeMs="等待下发物料！";
            make.makeProcess=0;
            GoodsMake.add(make);
           // MessageLog.ShowUserMessage(UserLogEnum.订单处理日志, "[" + make.good.name + "]准备配料!");

            if(loadinggoodAdapter!=null)
            {
                loadinggoodAdapter.Speak(R.raw.plks);
                loadinggoodAdapter.refresh();
            }
        }catch(Exception e){
            MessageLog.ShowInfo( "增加订单异常！"+e.getMessage());
        }
    }

    /**
     * 根据子订单id,物料id修改制作进度
     * @param suborderID
     * @param makeMs
     * @param count
     */
    public void UpdateGoodsMake(String suborderID,String makeMs,int count,int key,Boolean bz)
    {
        try
        {
            for (int m=0;m<GoodsMake.size();m++)
            {
                if(GoodsMake.get(m).subOrder.id.equals(suborderID))
                {
                    if(GoodsMake.get(m).subOrder.status==0)
                    {
                        GoodsMake.get(m).subOrder.status=1;
                        QueryDB.UpdateSubOrder(GoodsMake.get(m).subOrder);
                    }

                    GoodsMake.get(m).makeStatus= MakeStatus.制作中;
                    GoodsMake.get(m).makeMs=makeMs;
                    GoodsMake.get(m).makeProcess=(int)(((count*1.00)/ GoodsMake.get(m).recipes.size())*100);

                    if(loadinggoodAdapter!=null) {
                        loadinggoodAdapter.Speak(R.raw.plzqsh);
                        loadinggoodAdapter.refresh();
                    }
                    return;
                }
            }
        }catch(Exception e){
        }
    }
    /**
     * 根据子订单id,设置订单制作完成
     */
    public void DeleteGoodsMake(String suborderID)
    {
        try
        {
            ResGoodsMake good=null;
            for (ResGoodsMake item:GoodsMake)
            {
                if(item.subOrder.id.equals(suborderID))
                {
                    item.makeStatus=MakeStatus.制作完成;
                    item.makeMs="";
                    item.makeProcess=100;
                    item.subOrder.status=2;
                    QueryDB.UpdateSubOrder(item.subOrder);
                    good=item;
                }
            }

            if(good!=null)
            {
                GoodsMake.remove(good);
            }

            if(loadinggoodAdapter!=null)
            {
                loadinggoodAdapter.Speak(R.raw.plwc);
                loadinggoodAdapter.refresh();
            }

        }catch(Exception e){
        }
    }
    //endregion

    //region 配方数据
    /**
     * 详细配方
     */
    public ArrayList<ResGoodsRecipe> Recipe=new ArrayList<>();
    /**
     * 属性数据
     */
    public ArrayList<ResGoodProperty> bpa_goodproperties = new ArrayList<>();
    public pfsx_adapter sxadapter=null;
    /**
     * 加载商品配方
     */
    public void GetMainGoodProperty()
    {
        bpa_goodproperties.clear();
        ArrayList<BPA_GOODPROPERTY> da = QueryDB.GetGoodsPropertyALL("0");
        for (BPA_GOODPROPERTY item : da) {
            ResGoodProperty re = new ResGoodProperty();
            re.id = item.id;
            re.name = item.name;

            ArrayList<BPA_GOODPROPERTY> zsx = QueryDB.GetGoodsPropertyALL(item.id);
            re.child = new ArrayList<>();


            ArrayList<ResGoodProperty> _chid = new ArrayList<>();
            for (BPA_GOODPROPERTY k : zsx) {
                ResGoodProperty m = new ResGoodProperty();
                m.id = k.id;
                m.name = k.name;
                m.isSelect = false;
                _chid.add(m);
            }
            re.child = _chid;
            re.GoodsTypeId=item.GoodsTypeId;
            re.sort= item.sort;
            bpa_goodproperties.add(re);
        }

        for (ResGoodProperty item : bpa_goodproperties) {
            int i = 0;
            for (ResGoodProperty c : item.child) {
                if (i == 0) {
                    c.isSelect = true;
                }
                i++;
            }
        }
    }
    //endregion

    //region 流速校验
    public ArrayList<SilosLsjyMode> SilosLsjy = new ArrayList<SilosLsjyMode>();
    public lsjy_adapter lsjyAdapter=null;
    /**
     * 获取流速料仓数据
     */
    public void GetSilosLsjy()
    {
        try {
            SilosLsjy=new ArrayList<>();
            //获取料仓数据
            ArrayList<BPA_SILOS> bpa_silos = QueryDB.GetSilosALL();
            //加载materials数据
            if (bpa_silos.size() > 0) {

//                Object[] jzkg= ExecuteTheRecipe.ReadPLC("通道1校准开关",20);
//                Object[] jzz= ExecuteTheRecipe.ReadPLC("校准值1",20);

                for (BPA_SILOS silo : bpa_silos) {
                    List<BPA_MATERIAL> m = QueryDB.GetMaterialBySilosID(silo.id);
                    SilosLsjyMode mode=new SilosLsjyMode();
                    mode.num= silo.num;
                    mode.name= silo.name;
                    mode.materialName=m.size() > 0?m.get(0).name:"未设置";
                    //mode.xs= ExecuteTheRecipe.getCalibrationValueXS(silo.num)+"";
//                    Object kg=jzkg[silo.num-1];
//                    Object _val=jzz[silo.num-1];
//                    short val=_val==null?0:(short)_val;
//                    String s = String.valueOf(val);
                    mode.jzkg= false;//kg==null?false:(boolean) kg;
                    mode.Value="0.0";// //String.format("%.1f", (Double.parseDouble(s) / 10));
                    mode.mgtime=silo.bValue;
                    mode.id=silo.id;
                    SilosLsjy.add(mode);
                }
            }

            if (DataBus.getInstance().lsjyAdapter!=null)
            {
                DataBus.getInstance().lsjyAdapter.refresh();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void GetSilosLsjyValue()
    {
        Object[] jzkg= ExecuteTheRecipe.ReadPLC("通道1校准开关",20);
        Object[] jzz= ExecuteTheRecipe.ReadPLC("校准值1",20);
        for (SilosLsjyMode mode:SilosLsjy)
        {
            Object kg=jzkg[mode.num-1];
            Object _val=jzz[mode.num-1];
            short val=_val==null?0:(short)_val;
            String s = String.valueOf(val);
            mode.jzkg= kg==null?false:(boolean) kg;
            mode.Value= String.format("%.1f", (Double.parseDouble(s) / 10));
        }
        if (DataBus.getInstance().lsjyAdapter!=null)
        {
            DataBus.getInstance().lsjyAdapter.refresh();
        }
    }
    //endregion

    //region 温度设置
    public ArrayList<wdszMode> wdszModes = new ArrayList<wdszMode>();
    public wdsz_adapter wdszAdapter=null;
    public void GetWdsz()
    {
        try {
            wdszModes=new ArrayList<>();

            List<String> names=new ArrayList<>();
            if (ConfigName.getInstance().versionSelectionEnum.equals("配料吧台")) {
                names.add("水池温度");
            }else
            {
                names.add("水池温度");
                names.add("果糖左温度");
                names.add("果糖右温度");
            }
            for (String item:names)
            {
                wdszMode mode=new wdszMode();
                mode.name=item;
                mode.temp=0;
                //Object sx=ExecuteTheRecipe.ReadPLC(item+"设置");
                mode.tempup=0;//sx==null?0:(int)sx;
                mode.autoheat=false;
                if(item.equals("水池温度"))
                {
                    mode.autoheat=ConfigName.getInstance().AutomaticHeating;
                } else if (item.equals("果糖左温度")) {
                    mode.autoheat=ConfigName.getInstance().GT1_AutomaticHeating;
                }else if (item.equals("果糖右温度")) {
                    mode.autoheat=ConfigName.getInstance().GT2_AutomaticHeating;
                }
                wdszModes.add(mode);
            }


            if (wdszAdapter!=null)
            {
                wdszAdapter.refresh();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void GetWD()
    {
        for (wdszMode item:wdszModes)
        {
            Object sx=ExecuteTheRecipe.ReadPLC(item.name+"设置");
            item.tempup=sx==null?0:(int)sx;
        }
        if (wdszAdapter!=null)
        {
            wdszAdapter.refresh();
        }
    }
    //endregion

    //region 自动清洗
    public boolean ZDQX_IsStart = false;
    public ArrayList<BPA_SUGAR> zdqx = new ArrayList<BPA_SUGAR>();
    public zdqxchid_adapter zdqxchidAdapter=null;
    public void GetZDQXChid()
    {
        try {
            DataBus.getInstance().ZDQX_IsStart=false;
            zdqx.clear();
            ArrayList<BPA_SUGAR> data= QueryDB.GetSugarALL();

            for(BPA_SUGAR item:data)
            {
                zdqx.add(item);
            }
            if (zdqxchidAdapter!=null)
            {
                zdqxchidAdapter.refresh();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //endregion

    //region 手动控制
    public LinearLayout sdkz_linrarlaout=null;
    public Activity activity;
    public void GetSDKZ(LinearLayout _layout, Activity sdkz_activity)
    {
        if(_layout!=null)
        {
            if(sdkz_linrarlaout==null)
            {
                sdkz_linrarlaout=_layout;
                activity=sdkz_activity;
            }
        }

        if(sdkz_linrarlaout!=null)
        {
            sdkz_linrarlaout.removeAllViews();
            List<Res_PLCADDRESS1> plcaddresses=new ArrayList<>();
            if (ConfigName.getInstance().versionSelectionEnum.equals("配料吧台")) {
                for (Res_PLCADDRESS1 item : ConfigName.getInstance().PlcAddress_配料吧台_手动) {
                    if(item.address.equals("-------------"))//这是标题
                    {
                        if(plcaddresses.size()>0)
                        {
                            sdkz_control sdkz = new sdkz_control(sdkz_linrarlaout.getContext(), null, plcaddresses,activity,true);
                            sdkz_linrarlaout.addView(sdkz);
                        }
                        plcaddresses=new ArrayList<>();
                        tab_control tab = new tab_control(sdkz_linrarlaout.getContext(), null, item.name);
                        sdkz_linrarlaout.addView(tab);
                    }else
                    {
                        plcaddresses.add(item);
                    }
                }
                if(plcaddresses.size()>0)
                {
                    sdkz_control sdkz = new sdkz_control(sdkz_linrarlaout.getContext(), null, plcaddresses,activity,true);
                    sdkz_linrarlaout.addView(sdkz);
                }
            }else
            {
                for (Res_PLCADDRESS1 item : ConfigName.getInstance().PlcAddress_奶茶机_手动) {
                    if(item.address.equals("-------------"))//这是标题
                    {
                        if(plcaddresses.size()>0)
                        {
                            sdkz_control sdkz = new sdkz_control(sdkz_linrarlaout.getContext(), null, plcaddresses,activity,true);
                            sdkz_linrarlaout.addView(sdkz);
                        }
                        plcaddresses=new ArrayList<>();
                        tab_control tab = new tab_control(sdkz_linrarlaout.getContext(), null, item.name);
                        sdkz_linrarlaout.addView(tab);
                    }else
                    {
                        plcaddresses.add(item);
                    }
                }
                if(plcaddresses.size()>0)
                {
                    sdkz_control sdkz = new sdkz_control(sdkz_linrarlaout.getContext(), null, plcaddresses,activity,true);
                    sdkz_linrarlaout.addView(sdkz);
                }
            }
        }
    }
    //endregion

    //region 设备状态
    /**
     * 设备状态列表
     */
    public ArrayList<StatusMode> statusModes = new ArrayList<StatusMode>();
    //endregion
}
