package com.bonait.bnframework.modules.home.adapter;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Switch;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.res.Res_PLCADDRESS1;
import com.bonait.bnframework.common.db.res.Res_ZDSF;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.image.MyBitmapUtils;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.fragment.mode.image_sp;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;
import com.suke.widget.SwitchButton;

import java.util.ArrayList;
import java.util.List;

public class clsfbc_adapter  extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final LayoutInflater mLayoutInflater;

    private Context context;

    List<Res_ZDSF> goods = new ArrayList<>();
    Object[] main_kg =new Object[6];
    Object[]  main_gxs   =new Object[6];
    Object[]  main_dxs   =new Object[6];
    Object[]  main_bcsj  =new Object[6];
    /**
     * 点击事件
     */
    public MyClickListener mListener=null;

    public clsfbc_adapter(Context context,List<Res_ZDSF> data,Object[] _kg,Object[] _gxs,Object[] _dxs,Object[] _bcsj) {
        this.context = context;
        mLayoutInflater = LayoutInflater.from(context);
        goods=data;
         main_kg=_kg;
         main_gxs =_gxs ;
         main_dxs =_dxs ;
         main_bcsj=_bcsj;

    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View inflate = mLayoutInflater.inflate(R.layout.item_clsfbc, parent, false);
        return new MyLCViewHolder1(inflate);

    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        try {
            if (holder instanceof MyLCViewHolder1) {
                MyLCViewHolder1 myViewHolder = (MyLCViewHolder1) holder;
                Res_ZDSF sf= goods.get(position);
                myViewHolder.td_text.setText(sf.name);
                Object kg=main_kg[position];
                myViewHolder.switch1.setChecked(kg==null?false:((boolean) kg));

                int index=position+1;
                Object gxs=main_gxs[position];
                myViewHolder.bc_text1.setText(gxs==null?"0":(gxs+""));
                Object dxs=main_dxs[position];
                myViewHolder.bc_text2.setText(dxs==null?"0":(dxs+""));

                Object time=main_bcsj[position];
                int timel=time==null?0:(Integer.parseInt(time.toString()));

                myViewHolder.bc_text3.setText(String.format ("%.1f", timel/10.0)+"");

                myViewHolder.save_botton.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {

                        Short H=0;
                        Short L=0;
                        Short time=0;
                        try {
                            H=Short.parseShort(myViewHolder.bc_text1.getText().toString()) ;
                            L=Short.parseShort(myViewHolder.bc_text2.getText().toString()) ;
                            //time=(Short)Math.round();
                            int ftime = (int)Math.round((Double.parseDouble(myViewHolder.bc_text3.getText().toString()) * 10));
                            time=(short) ftime;
                        }
                        catch (Exception ex)
                        {

                        }

                        ExecuteTheRecipe.WritePLC("高系数"+index,H,null);
                        ExecuteTheRecipe.WritePLC("低系数"+index,L,null);
                        ExecuteTheRecipe.WritePLC("补偿" + index + "时间", time, new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                ToastUtils.info(sf.name.toString()+",保存变量成功!");
                            }

                            @Override
                            public void onFailure(String ErrorMsg) {
                                ToastUtils.warning( sf.name.toString()+",保存变量失败!");
                            }
                        });
                    }
                });

                myViewHolder.switch1.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        boolean isopen=  myViewHolder.switch1.isChecked();
                        if (ConfigName.getInstance().PlcIsConnect)
                        {
                            ExecuteTheRecipe.WritePLC("通道"+index+"补偿开关",isopen,null);
                            ToastUtils.info( sf.name.toString()+(isopen?"打开":"关闭")+"成功!");

                        }else
                        {
                            ToastUtils.warning( sf.name.toString()+(isopen?"打开":"关闭")+"失败!PLC未连接！！");
                        }
                    }
                });
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private Activity findActivity(@NonNull Context context) {
        if (context instanceof Activity) {
            return (Activity) context;
        } else if (context instanceof ContextWrapper) {
            return findActivity(((ContextWrapper) context).getBaseContext());
        } else {
            return null;
        }
    }

    /**
     * 刷新
     *
     * @param
     */
    public void refresh() {
        Activity activity = findActivity(context);
        if (activity != null) {
            activity.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    try {
                        notifyDataSetChanged();
                    } catch (Exception e) {

                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return goods.size();
    }

    public static class MyLCViewHolder1 extends RecyclerView.ViewHolder {
        TextView td_text;//标题
        SwitchButton switch1;
        EditText bc_text1,bc_text2,bc_text3;

        Button save_botton;

        public MyLCViewHolder1(View view) {
            super(view);
            td_text=view.findViewById(R.id.td_text);
            switch1=view.findViewById(R.id.switch1);
            bc_text1=view.findViewById(R.id.bc_text1);
            bc_text2=view.findViewById(R.id.bc_text2);
            bc_text3=view.findViewById(R.id.bc_text3);
            save_botton=view.findViewById(R.id.save_botton);
        }
    }
}