package com.bonait.bnframework.modules.home.adapter;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.os.SystemClock;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.Chronometer;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.res.SilosLsjyMode;
import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.suke.widget.SwitchButton;

import java.sql.Struct;
import java.util.List;

/**
 * 流速校验
 */
public class lsjy_adapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final LayoutInflater mLayoutInflater;

    private Context context;

    public List<SilosLsjyMode> mainGoods = DataBus.getInstance().SilosLsjy;

    public lsjy_adapter(Context context) {
        this.context = context;
        mLayoutInflater = LayoutInflater.from(context);
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View inflate = mLayoutInflater.inflate(R.layout.lsjy_item, parent, false);
        return new MyGoodLCViewHolder(inflate);

    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        try {
            if (holder instanceof MyGoodLCViewHolder) {

                MyGoodLCViewHolder myViewHolder = (MyGoodLCViewHolder) holder;
                SilosLsjyMode goodsMake= mainGoods.get(position);
                String name= "通道"+goodsMake.num+"(" +goodsMake.name+")";
                myViewHolder.num=goodsMake.num;
                myViewHolder.name.setText(name+"");
                myViewHolder.wlname.setText(goodsMake.materialName+"");
                myViewHolder.control_switch.setChecked(goodsMake.jzkg);
                myViewHolder.edittext_tdzl.setText(goodsMake.Value+"");

                myViewHolder.edittext_mgsj.setText(goodsMake.mgtime+"");

                myViewHolder.control_switch.setOnCheckedChangeListener(new SwitchButton.OnCheckedChangeListener() {
                    @Override
                    public void onCheckedChanged(SwitchButton view, boolean isChecked) {
                        DataBus.getInstance().SilosLsjy.get(position).jzkg=isChecked;
                        ExecuteTheRecipe.WritePLC("通道" + goodsMake.num+"校准开关", isChecked, null);
                    }
                });

                myViewHolder.save_value.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        String value = myViewHolder.edittext_tdzl.getText().toString();
                        Short val = 0;
                        try {
                            val = (short) Math.round((Double.parseDouble(value) * 10));
                        } catch (Exception e) {
                        }
                        ExecuteTheRecipe.WritePLC("校准值" + goodsMake.num, val, new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                ToastUtils.info(name+"保存成功！");
                            }

                            @Override
                            public void onFailure(String ErrorMsg) {
                                ToastUtils.error(name+"保存失败！");
                            }
                        });

                        String value1 = myViewHolder.edittext_mgsj.getText().toString();
                        int val1 = 0;
                        try {
                            val1 =(value1==null|| value1.isEmpty())?0:Integer.parseInt(value1);
                            QueryDB.UpdateMGTime(DataBus.getInstance().SilosLsjy.get(position).id,val1);
                        } catch (Exception e) {
                        }

                    }
                });
                final int[] time = {0};
                final int[] zl = {0};
                //开始计算满管时间
                myViewHolder.save_mg.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        zl[0] =ExecuteTheRecipe.OutletWeigh;
                        StartTime(myViewHolder);
                    }
                });

                //为Chronomter绑定事件监听器,超过一小时自动日内告知
                myViewHolder.runtime.setOnChronometerTickListener(new Chronometer.OnChronometerTickListener() {
                    @Override
                    public void onChronometerTick(Chronometer chronometer) {
                        //如果计时到现在超过了一小时秒 10s
                        if (SystemClock.elapsedRealtime() - myViewHolder.runtime.getBase() > 10 * 1000) {
                            time[0] =StopTime(myViewHolder);
                            DataBus.getInstance().SilosLsjy.get(position).mgtime=time[0];
                            QueryDB.UpdateMGTime(DataBus.getInstance().SilosLsjy.get(position).id,time[0]);
                        }
                    }
                });

                ExecuteTheRecipe.WeighComplete=new IRun() {
                    @Override
                    public void Run() {
                        if(ExecuteTheRecipe.OutletWeigh >=(zl[0]+2))
                        {
                            time[0] =StopTime(myViewHolder);
                            DataBus.getInstance().SilosLsjy.get(position).mgtime=time[0];
                            QueryDB.UpdateMGTime(DataBus.getInstance().SilosLsjy.get(position).id,time[0]);
                        }
                    }
                };


            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 启动定时器
     */
    public void StartTime(MyGoodLCViewHolder myGoodLCViewHolder) {
        myGoodLCViewHolder.jishiqi.setVisibility(View.VISIBLE);
        myGoodLCViewHolder.main_laout.setVisibility(View.GONE);

        myGoodLCViewHolder.runtime.setBase(SystemClock.elapsedRealtime());
        myGoodLCViewHolder.runtime.start();

        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    //自动模式
                    ExecuteTheRecipe.WritePLC("手自切换", false, null);
                    //开启
                    ExecuteTheRecipe.WritePLC("手动控制"+myGoodLCViewHolder.num,true,null);
                } catch (Exception e) {

                }
            }
        }).start();
    }

    /**
     * 停止定时器
     */
    public int StopTime(MyGoodLCViewHolder myGoodLCViewHolder) {
        myGoodLCViewHolder.jishiqi.setVisibility(View.GONE);
        myGoodLCViewHolder.main_laout.setVisibility(View.VISIBLE);
        long elapsedMillis = SystemClock.elapsedRealtime() - myGoodLCViewHolder.runtime.getBase();
        myGoodLCViewHolder.runtime.stop();

        int time=(int) (elapsedMillis / 1000);
        myGoodLCViewHolder.edittext_mgsj.setText(time+"");

        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ExecuteTheRecipe.WritePLC("手动控制"+myGoodLCViewHolder.num,false,null);
                } catch (Exception e) {

                }
            }
        }).start();
        return  time;//当前点击多少秒
    }

    private Activity findActivity(@NonNull Context context) {
        if (context instanceof Activity) {
            return (Activity) context;
        } else if (context instanceof ContextWrapper) {
            return findActivity(((ContextWrapper) context).getBaseContext());
        } else {
            return null;
        }
    }
    /**
     * 刷新
     * @param
     */
    public void refresh(){
        Activity activity= findActivity(context);
        if(activity!=null)
        {
            activity.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    try {
                        notifyDataSetChanged();
                    } catch (Exception e) {

                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return mainGoods.size();
    }

    public static class MyGoodLCViewHolder extends RecyclerView.ViewHolder {
        /**
         * 通道名称
         */
        TextView name;
        /**
         * 物料名称
         */
        TextView wlname;
        /**
         * 校准开关
         */
        SwitchButton control_switch;
        /**
         * 通道重量
         */
        EditText edittext_tdzl;
        /**
         * 保存值
         */
        Button save_value;


        EditText edittext_mgsj;
        Button save_mg;

        RelativeLayout jishiqi;
        LinearLayout main_laout;
        Chronometer runtime;

        int num=0;
        public MyGoodLCViewHolder(View view) {
            super(view);
            name = (TextView) view.findViewById(R.id.name);
            wlname = (TextView) view.findViewById(R.id.wlname);
           // edittext_xs=(EditText) view.findViewById(R.id.edittext_xs);
            control_switch = (SwitchButton)view.findViewById(R.id.control_switch);
            edittext_tdzl=(EditText) view.findViewById(R.id.edittext_tdzl);
            save_value=(Button) view.findViewById(R.id.save_value);


            edittext_mgsj=(EditText) view.findViewById(R.id.edittext_mgsj);
            save_mg=(Button) view.findViewById(R.id.save_mg);

            jishiqi=view.findViewById(R.id.jishiqi);
            main_laout=view.findViewById(R.id.main_laout);
            runtime=view.findViewById(R.id.runtime);
        }
    }
}
