package com.bonait.bnframework.modules.home.adapter;

import android.app.Activity;
import android.content.Context;
import android.content.ContextWrapper;
import android.os.Handler;
import android.os.Message;
import android.text.InputFilter;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.business.MainInit;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.res.SilosLsjyMode;
import com.bonait.bnframework.common.db.res.wdszMode;
import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.helper.InputFilterMinMax;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.suke.widget.SwitchButton;

import java.util.List;

public class wdsz_adapter  extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final LayoutInflater mLayoutInflater;

    private Context context;

    public List<wdszMode> wdszModes = DataBus.getInstance().wdszModes;

    public wdsz_adapter(Context context) {
        this.context = context;
        mLayoutInflater = LayoutInflater.from(context);
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View inflate = mLayoutInflater.inflate(R.layout.wdsz_item, parent, false);
        return new WDSZViewHolder(inflate);

    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        try {
            if (holder instanceof WDSZViewHolder) {
                WDSZViewHolder myViewHolder = (WDSZViewHolder) holder;
                wdszMode goodsMake= wdszModes.get(position);

                myViewHolder.name.setText(goodsMake.name+"");
                myViewHolder.edittext_sx.setText(goodsMake.tempup+"");
                if(goodsMake.name.equals("水池温度"))
                {
                    myViewHolder.edittext_sx.setFilters(new InputFilter[]{ new InputFilterMinMax("0", "45")});
                } else if (goodsMake.name.equals("果糖左温度")) {
                    myViewHolder.edittext_sx.setFilters(new InputFilter[]{ new InputFilterMinMax("0", "60")});
                }else if (goodsMake.name.equals("果糖右温度")) {
                    myViewHolder.edittext_sx.setFilters(new InputFilter[]{ new InputFilterMinMax("0", "60")});
                }
                myViewHolder.temp.setText(goodsMake.temp+"");
                myViewHolder.control_switch.setChecked(goodsMake.autoheat);

                Handler mHandler = new Handler() {
                    public void handleMessage(Message msg) {
                        switch (msg.what) {
                            case 0:
                                if(goodsMake.name.equals("水池温度"))
                                {
                                    myViewHolder.temp.setText(ExecuteTheRecipe.WaterTemp+"");
                                } else if (goodsMake.name.equals("果糖左温度")) {
                                    myViewHolder.temp.setText(ExecuteTheRecipe.SugarTempLeft+"");
                                }else if (goodsMake.name.equals("果糖右温度")) {
                                    myViewHolder.temp.setText(ExecuteTheRecipe.SugarTempRight+"");
                                }
                                break;
                            case 1:

                                break;
                            case 2:

                                break;
                        }

                    }
                };
                ExecuteTheRecipe.TempComplete=new IRun() {
                    @Override
                    public void Run() {
                        mHandler.sendEmptyMessage(0);
                    }
                };
                myViewHolder.control_switch.setOnCheckedChangeListener(new SwitchButton.OnCheckedChangeListener() {
                    @Override
                    public void onCheckedChanged(SwitchButton view, boolean isChecked) {
                        //设置
                        goodsMake.autoheat=isChecked;
                        if(goodsMake.name.equals("水池温度"))
                        {
                            ConfigName.getInstance().AutomaticHeating=goodsMake.autoheat;
                        } else if (goodsMake.name.equals("果糖左温度")) {
                            ConfigName.getInstance().GT1_AutomaticHeating=goodsMake.autoheat;
                        }else if (goodsMake.name.equals("果糖右温度")) {
                            ConfigName.getInstance().GT2_AutomaticHeating=goodsMake.autoheat;
                        }
                        ConfigData.getInstance().SavePZ();

                        if(!isChecked) //关闭加热
                        {
                            ExecuteTheRecipe.WritePLC(goodsMake.name+"加热",false,null);
                        }
                    }
                });

                myViewHolder.save_value.setOnClickListener(new View.OnClickListener() {
                    @Override
                    public void onClick(View view) {
                        int up = Integer.parseInt((myViewHolder.edittext_sx.getText().toString().isEmpty() ? "0" : myViewHolder.edittext_sx.getText().toString()));
                        if (up <= 0) {
                            ToastUtils.error("温度不能小于0!请调整后重试.");
                            return;
                        }
                        ExecuteTheRecipe.WritePLC(goodsMake.name + "设置", up, new IWriteCallBack() {
                            @Override
                            public void onSuccess() {
                                ToastUtils.info(goodsMake.name+"保存成功！");
                            }

                            @Override
                            public void onFailure(String ErrorMsg) {
                                ToastUtils.error(goodsMake.name+"保存失败！");
                            }
                        });
                    }
                });


            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    private Activity findActivity(@NonNull Context context) {
        if (context instanceof Activity) {
            return (Activity) context;
        } else if (context instanceof ContextWrapper) {
            return findActivity(((ContextWrapper) context).getBaseContext());
        } else {
            return null;
        }
    }
    /**
     * 刷新
     * @param
     */
    public void refresh(){
        Activity activity= findActivity(context);
        if(activity!=null)
        {
            activity.runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    try {
//                        wdszModes.clear();
//                        wdszModes = DataBus.getInstance().wdszModes;
                        notifyDataSetChanged();
                    } catch (Exception e) {

                    }
                }
            });
        }
    }

    @Override
    public int getItemCount() {
        return wdszModes.size();
    }

    public static class WDSZViewHolder extends RecyclerView.ViewHolder {
        /**
         * 名称
         */
        TextView name;
        /**
         * 温度上限
         */
        EditText edittext_sx;
        /**
         * 当前温度
         */
        TextView temp;
        /**
         * 自动加热
         */
        SwitchButton control_switch;
        /**
         * 保存值
         */
        Button save_value;
        public WDSZViewHolder(View view) {
            super(view);
            name = (TextView) view.findViewById(R.id.name);
            edittext_sx=(EditText) view.findViewById(R.id.edittext_sx);
            temp = (TextView) view.findViewById(R.id.temp);
            control_switch = (SwitchButton)view.findViewById(R.id.control_switch);
            save_value=(Button) view.findViewById(R.id.save_value);
        }
    }
}
