package com.bonait.bnframework.modules.home.fragment.from.fragment;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.helper.WrapContentLinearLayoutManager;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.bonait.bnframework.modules.home.adapter.clsfbc_adapter;
import com.bonait.bnframework.modules.home.adapter.image_sp_adapter;
import com.bonait.bnframework.modules.home.adapter.lsjy_adapter;
import com.orhanobut.logger.Logger;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class JiaoYan_clsfbc_fragment extends BaseFragment {


    @BindView(R.id.recycler_clsfbc)
    RecyclerView recycler_clsfbc;//出料算法补偿
    private Context context;
    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_jiaoyan_clsfbc, null);
        ButterKnife.bind(this, root);
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Logger.d("我的fragment创建");
        context = getContext();
        InitView();
    }
    /**
     * 初始化界面
     */
    public void InitView() {
        Initdata();
    }

//    boolean IsStart = false;
//    @OnClick({R.id.save_time,R.id.bt_start})
//    public void onViewClicked(View view) {
//
//    }


    //region 数据加载
    /**
     * 初始化数据加载
     */
    public void Initdata() {
        try {
            MyLayoutManager layout = new MyLayoutManager();
            layout.setAutoMeasureEnabled(true);
            recycler_clsfbc.setLayoutManager(layout);
            new Thread(new Runnable() {
                @Override
                public void run() {
                    try {
                        Object[] kg =ExecuteTheRecipe.ReadPLC("通道1补偿开关",6);
                        Object[] gxs =ExecuteTheRecipe.ReadPLC("高系数1",6);
                        Object[] dxs =ExecuteTheRecipe.ReadPLC("低系数1",6);
                        Object[] bcsj =ExecuteTheRecipe.ReadPLC("补偿1时间",6);
                        getActivity().runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                clsfbc_adapter spadapter = new clsfbc_adapter(context
                                        , ConfigName.getInstance().zdsfs_出料算法
                                ,kg,gxs,dxs,bcsj);
                                recycler_clsfbc.setAdapter(spadapter);
                            }
                        });

                    } catch (Exception e) {

                    }
                }
            }).start();


        } catch (Exception e) {

        }
    }
    //endregion

    @Override
    public void onDestroy() {
        super.onDestroy();
        Logger.d("我的fragment销毁");
    }

    /**
     * 当在activity设置viewPager + BottomNavigation + fragment时，
     * 为防止viewPager左滑动切换界面，与fragment左滑返回上一界面冲突引起闪退问题，
     * 必须加上此方法，禁止fragment左滑返回上一界面。
     * <p>
     * 切记！切记！切记！否则会闪退！
     * <p>
     * 当在fragment设置viewPager + BottomNavigation + fragment时，则不会出现这个问题。
     */
    @Override
    protected boolean canDragBack() {
        return false;
    }
}