package com.bonait.bnframework.modules.home.fragment.from.fragment;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.InputType;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.helper.WrapContentLinearLayoutManager;
import com.bonait.bnframework.common.utils.NetworkUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.adapter.lsjy_adapter;
import com.bonait.bnframework.modules.home.adapter.wl_adapter;
import com.orhanobut.logger.Logger;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;
import com.qmuiteam.qmui.widget.section.QMUIStickySectionLayout;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class JiaoYan_dzcjy_fragment extends BaseFragment  {

    @BindView(R.id.ldjz)
    Button ldjz;//零点校准
    @BindView(R.id.edittext_zl)
    EditText edittext_zl;//砝码重量
    @BindView(R.id.jzzl)
    Button jzzl;//校正重量

    private Context context;
    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_jiaoyan_dzcjy, null);
        ButterKnife.bind(this, root);
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Logger.d("我的fragment创建");
        context = getContext();
        InitView();
    }

    /**
     * 初始化界面
     */
    public void InitView() {
        Initdata();
    }


    boolean IsOpen=false;
    @OnClick({R.id.ldjz,R.id.jzzl})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.ldjz://零点校准
                IsOpen= ExecuteTheRecipe.StartJiaoYanMode();
                if(IsOpen)
                {
                    ToastUtils.info("开启零点校正成功!");
                }else
                {
                    ToastUtils.error("开启零点校正失败,请检测plc连接!");
                }
                break;
            case R.id.jzzl://校正重量
                if(!IsOpen)
                {
                    ToastUtils.info("请先点击[零点校正],进入校正模式!");
                    return;
                }

                String outres = edittext_zl.getText().toString().trim();
                if (!outres.equals("")) {
                    ExecuteTheRecipe.WritePLC("砝码值", Short.parseShort(outres), new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            ExecuteTheRecipe.WritePLC("砝码值写入",true,null);
                            ToastUtils.info("校正重量成功！");
                        }

                        @Override
                        public void onFailure(String ErrorMsg) {
                            ToastUtils.error("校正重量失败！");
                        }
                    });
                }else
                {
                    ToastUtils.info("砝码值不能为空！");
                }

                ExecuteTheRecipe.StopJiaoYanMode();
                IsOpen=false;
                break;
        }
    }


    //region 数据加载
    /**
     * 初始化数据加载
     */
    public void Initdata() {
        try {

        } catch (Exception e) {

        }
    }
    //endregion

    @Override
    public void onDestroy() {
        super.onDestroy();
        Logger.d("我的fragment销毁");
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ExecuteTheRecipe.StopJiaoYanMode();
                } catch (Exception e) {

                }
            }
        }).start();
    }

    /**
     * 当在activity设置viewPager + BottomNavigation + fragment时，
     * 为防止viewPager左滑动切换界面，与fragment左滑返回上一界面冲突引起闪退问题，
     * 必须加上此方法，禁止fragment左滑返回上一界面。
     * <p>
     * 切记！切记！切记！否则会闪退！
     * <p>
     * 当在fragment设置viewPager + BottomNavigation + fragment时，则不会出现这个问题。
     */
    @Override
    protected boolean canDragBack() {
        return false;
    }
}