package com.bonait.bnframework.modules.home.fragment.from.fragment;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.content.Context;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_GOODSTYPE;
import com.bonait.bnframework.common.db.res.SilosLsjyMode;
import com.bonait.bnframework.common.helper.I.IRun;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.helper.MediaPlayerHelper;
import com.bonait.bnframework.common.helper.WrapContentLinearLayoutManager;
import com.bonait.bnframework.common.linktab.LinkMode;
import com.bonait.bnframework.common.linktab.TopItemDecoration;
import com.bonait.bnframework.common.linktab.makegood.MakeGoodLeftAdapter;
import com.bonait.bnframework.common.linktab.makegood.MakeGoodRightAdapter;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.modules.home.adapter.lsjy_adapter;
import com.orhanobut.logger.Logger;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

public class JiaoYan_lsjy_fragment extends BaseFragment {

    @BindView(R.id.Recy_Lsjy)
    RecyclerView Recy_Lsjy;//流速校验

    @BindView(R.id.zhongliang)
    TextView zhongliang;//实时重量

    @BindView(R.id.edittext_jzsj)
    EditText edittext_jzsj;//校准时间

    @BindView(R.id.edittext_fzsj)
    EditText edittext_fzsj;//反转时间

    @BindView(R.id.edittext_cl)
    EditText edittext_cl;//出料重量

    @BindView(R.id.linelayout_fanzhuantime)
    LinearLayout linelayout_fanzhuantime;//出料重量


    private Context context;
    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_jiaoyan_lsjy, null);
        ButterKnife.bind(this, root);
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Logger.d("我的fragment创建");
        context = getContext();
        InitView();
    }
    /**
     * 初始化界面
     */
    public void InitView() {
        Initdata();
        Run();
    }


    public int selectIndexSilos=-99;

    @OnClick({R.id.save_jzsj,R.id.save_fzsj
            ,R.id.czql,R.id.save_czql,R.id.ksjz
            ,R.id.kscl
    })
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.save_jzsj://保存校准时间
                try {
                    String stime = edittext_jzsj.getText().toString();
                    if (stime.equals("")) {
                        ToastUtils.info("校准基准时间不能为空！");
                        return;
                    }
                    int ftime = 0;
                    try {
                        ftime = (int) Math.round((Double.parseDouble(stime) * 10));
                    } catch (Exception e) {
                        ToastUtils.error("校准基准时间异常！" + e.getMessage());
                        return;
                    }
                    ExecuteTheRecipe.WritePLC("基准时间", (short) ftime, new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            ToastUtils.info("校准基准时间保存成功！");
                        }
                        @Override
                        public void onFailure(String ErrorMsg) {
                            ToastUtils.error("校准基准时间保存失败！");
                        }
                    });
                } catch (WindowManager.BadTokenException e) {
                    ToastUtils.error("校准基准时间保存配置异常！" + e.getMessage());
                }
                break;
            case R.id.save_fzsj://保存反转时间
                try {
                    String stime = edittext_fzsj.getText().toString();
                    if (stime.equals("")) {
                        ToastUtils.info("反转时间不能为空！");
                        return;
                    }
                    int ftime = 0;
                    try {
                        ftime = (int) Math.round((Double.parseDouble(stime) * 10));
                    } catch (Exception e) {
                        ToastUtils.error("反转时间异常！" + e.getMessage());
                        return;
                    }
                    ExecuteTheRecipe.WritePLC("反转时间", (short) ftime, new IWriteCallBack() {
                        @Override
                        public void onSuccess() {
                            ToastUtils.info("反转时间保存成功！");
                        }
                        @Override
                        public void onFailure(String ErrorMsg) {
                            ToastUtils.error("反转时间保存失败！");
                        }
                    });
                } catch (WindowManager.BadTokenException e) {
                    ToastUtils.error("反转时间保存配置异常！" + e.getMessage());
                }
                break;
            case R.id.czql://称重清零
            case R.id.save_czql:
                ExecuteTheRecipe.WritePLC("重量清零", true, new IWriteCallBack() {
                    @Override
                    public void onSuccess() {
                        ToastUtils.info("清零成功！");
                    }
                    @Override
                    public void onFailure(String ErrorMsg) {
                        ToastUtils.error("清零失败！");
                    }
                });
                break;
            case R.id.ksjz://开始校准
                //切换手动


                //region 判断是否只勾选了一个料仓
                SelectSilos();
                //endregion

                //判断是否为果糖
                if (!ConfigName.getInstance().versionSelectionEnum.equals("配料吧台"))
                {
                    if(selectIndexSilos==11)
                    {
                        Object sx=ExecuteTheRecipe.ReadPLC("果糖左温度设置");
                        int wdsz=sx==null?0:(int)sx;

                        if(ExecuteTheRecipe.SugarTempLeft<wdsz)
                        {
                            ToastUtils.warning("果糖左仓温度未达到设置值,不允许校准...");
                            return;
                        }
                    }else if(selectIndexSilos==12)
                    {
                        Object sx=ExecuteTheRecipe.ReadPLC("果糖右温度设置");
                        int wdsz=sx==null?0:(int)sx;
                        if(ExecuteTheRecipe.SugarTempRight<wdsz)
                        {
                            ToastUtils.warning("果糖右仓温度未达到设置值,不允许校准...");
                            return;
                        }
                    }
                }

                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            ExecuteTheRecipe.WritePLC("校准完成",false,null);

                            ExecuteTheRecipe.WritePLC("手自切换", false, null);
                            ExecuteTheRecipe.WritePLC("通道校准", true, new IWriteCallBack() {
                                @Override
                                public void onSuccess() {
                                    ToastUtils.info("启动通道校准成功！");
                                }
                                @Override
                                public void onFailure(String ErrorMsg) {
                                    ToastUtils.error("启动通道校准失败！");
                                }
                            });
                        } catch (Exception e) {

                        }
                    }
                }).start();
                break;
            case R.id.kscl://开始出料
                String zltext = edittext_cl.getText().toString();
                if (zltext.equals("")) {
                    ToastUtils.warning("出料重量不能为空！");
                    return;
                }
                double zl = 0;
                try {
                    zl = Double.parseDouble(zltext);
                } catch (Exception e) {
                    ToastUtils.warning("出料重量获取异常！" + e.getMessage());
                    return;
                }

                if(zl<=0)
                {
                    ToastUtils.warning("出料重量至少大于0g！");
                    return;
                }

                if (!ExecuteTheRecipe.IsCup)
                {
                    ToastUtils.warning("出料口没有检测到器皿！");
                    return;
                }

                //region 判断是否只勾选了一个料仓
                SelectSilos();
                //endregion



                if (selectIndexSilos==-88)
                {
                    ToastUtils.warning("只能打开一个通道开关！");
                    return;
                }

                if (selectIndexSilos<=0)
                {
                    ToastUtils.warning("请打开通道开关！");
                    return;
                }

                short kkk=(short) ((int) (zl * 10));
                new Thread(new Runnable() {
                    @Override
                    public void run() {
                        try {
                            ExecuteTheRecipe.WritePLC("配料完成",false,null);

                            ExecuteTheRecipe.WritePLC("手自切换", true,null);
                            ExecuteTheRecipe.WritePLC("需求值" + selectIndexSilos,kkk,new IWriteCallBack() {
                                @Override
                                public void onSuccess() {
                                    ExecuteTheRecipe.WritePLC("配料启动", true, null);
                                }
                                @Override
                                public void onFailure(String ErrorMsg) {
                                }
                            });
                        } catch (Exception e) {

                        }
                    }
                }).start();
                ToastUtils.warning("需求值下发成功！开始配料......");
                break;
        }
    }

    /**
     * 判断是否只勾选了一个料仓
     */
    public void SelectSilos()
    {
        //region 判断是否只勾选了一个料仓
        selectIndexSilos=-99;
        for (SilosLsjyMode item:DataBus.getInstance().SilosLsjy)
        {
            if(item.jzkg)
            {
                if(selectIndexSilos==-99)
                {
                    selectIndexSilos=item.num;
                }else
                {
                    selectIndexSilos=-88;
                }
            }
        }
        //endregion
    }
    //region 数据加载
    /**
     * 初始化数据加载
     */
    public void Initdata() {
        try {
            //顶部料仓信息
            new Thread(new Runnable() {
                @Override
                public void run() {
                    try {
                        DataBus.getInstance().GetSilosLsjy();
                        getActivity().runOnUiThread(new Runnable() {
                            @Override
                            public void run() {

                                if(isAdded())
                                {
                                    Recy_Lsjy.setLayoutManager(new WrapContentLinearLayoutManager(getContext(), LinearLayoutManager.HORIZONTAL,false));
                                    DataBus.getInstance().lsjyAdapter = new lsjy_adapter(getContext());
                                    Recy_Lsjy.setAdapter(DataBus.getInstance().lsjyAdapter);
                                }
                            }
                        });
                        DataBus.getInstance().GetSilosLsjyValue();
                    } catch (Exception e) {

                    }
                }
            }).start();

            new Thread(new Runnable() {
                @Override
                public void run() {
                    try {
                        //底部按钮信息
                        Object obj= ExecuteTheRecipe.ReadPLC("基准时间");
                        String time = obj==null?"0":obj.toString();
                        getActivity().runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                //校准时间
                                edittext_jzsj.setText(String.format("%.1f", (Double.parseDouble(time) / 10)));
                                if (ConfigName.getInstance().versionSelectionEnum.equals("配料吧台"))
                                {
                                    Object obj1= ExecuteTheRecipe.ReadPLC("反转时间");
                                    String fztime = obj1==null?"0":obj1.toString();
                                    edittext_fzsj.setText(String.format("%.1f", (Double.parseDouble(fztime) / 10)));
                                }else
                                {
                                    linelayout_fanzhuantime.setVisibility(View.GONE);
                                }
                            }
                        });

                    } catch (Exception e) {

                    }
                }
            }).start();

        } catch (Exception e) {

        }
    }

    private Handler mHandler = new Handler() {
        public void handleMessage(Message msg) {
            switch (msg.what) {
                case 0:
                    zhongliang.setText(String.valueOf((int)ExecuteTheRecipe.OutletWeigh / 10.0) + " g");
                    break;
                case 1:

                    break;
                case 2:

                    break;
            }

        }
    };

    /**
     * 实时显示线程
     */
    public void Run() {
        ExecuteTheRecipe.WeighComplete=new IRun() {
            @Override
            public void Run() {
                mHandler.sendEmptyMessage(0);
            }
        };

        ExecuteTheRecipe.OnChargeMixtureComNotPar = new IRun() {
            @Override
            public void Run() {
                if (selectIndexSilos > 0) {
                    final int kkk = selectIndexSilos;
                    try {

                        getActivity().runOnUiThread(new Runnable() {
                            @Override
                            public void run() {
                                try {
                                    new Handler().postDelayed(new Runnable() {
                                        @Override
                                        public void run() {
                                            ToastUtils.warning("通道校准完成！");

                                            // 在2秒后执行按钮操作
                                            int zhongliangxianshi=ExecuteTheRecipe.OutletWeigh;
                                            ExecuteTheRecipe.WritePLC("校准值"+kkk,(short) zhongliangxianshi,null);

                                            String s = String.valueOf(zhongliangxianshi);
                                            for (SilosLsjyMode item:DataBus.getInstance().SilosLsjy)
                                            {
                                                if(kkk==item.num)
                                                {
                                                    item.Value=String.format("%.1f", (Double.parseDouble(s) / 10));
                                                    ToastUtils.warning("重量！" +item.Value);
                                                }
                                            }
                                            if (DataBus.getInstance().lsjyAdapter!=null)
                                            {
                                                DataBus.getInstance().lsjyAdapter.refresh();
                                            }
                                        }
                                    }, 2000);

                                } catch (Exception e) {
                                    ToastUtils.error("重量解析显示异常！" + e.getMessage());
                                }
                            }
                        });


                    } catch (Exception ex) {
                        Log.d("dsds", "Run: " + ex.getMessage());
                    }
                    selectIndexSilos = -99;
                }
            }
        };
    }
    //endregion

    @Override
    public void onDestroy() {
        super.onDestroy();
        Logger.d("我的fragment销毁");
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ExecuteTheRecipe.WritePLC("手自切换", true, null);
                } catch (Exception e) {

                }
            }
        }).start();
    }

    /**
     * 当在activity设置viewPager + BottomNavigation + fragment时，
     * 为防止viewPager左滑动切换界面，与fragment左滑返回上一界面冲突引起闪退问题，
     * 必须加上此方法，禁止fragment左滑返回上一界面。
     * <p>
     * 切记！切记！切记！否则会闪退！
     * <p>
     * 当在fragment设置viewPager + BottomNavigation + fragment时，则不会出现这个问题。
     */
    @Override
    protected boolean canDragBack() {
        return false;
    }
}