package com.bonait.bnframework.modules.home.fragment.from.fragment;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ConfigData;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.base.BaseFragment;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.helper.I.IWriteCallBack;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.orhanobut.logger.Logger;
import com.suke.widget.SwitchButton;

import butterknife.BindView;
import butterknife.ButterKnife;

public class JiaoYan_zdbs_fragment extends BaseFragment {

    @BindView(R.id.control_switch_zdbs)
    SwitchButton control_switch_zdbs;//自动补水
    @BindView(R.id.edittext_ycsj)
    EditText edittext_ycsj;//自动补水延迟时间
    @BindView(R.id.save_time)
    Button save_time;//自动补水延迟时间
    private Context context;

    @Override
    protected View onCreateView() {
        View root = LayoutInflater.from(getActivity()).inflate(R.layout.fragment_jiaoyan_zdbs, null);
        ButterKnife.bind(this, root);
        return root;
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        Logger.d("我的fragment创建");
        context = getContext();
        InitView();
    }

    /**
     * 初始化界面
     */
    public void InitView() {
        Initdata();
    }

    /**
     * 初始化数据加载
     */
    public void Initdata() {
        control_switch_zdbs.setChecked(ConfigName.getInstance().AutomaticWaterRefill);
        edittext_ycsj.setText(ConfigName.getInstance().AutomaticWaterRefillTime);
        control_switch_zdbs.setOnCheckedChangeListener(new SwitchButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(SwitchButton view, boolean isChecked) {
                //设置
                ConfigName.getInstance().AutomaticWaterRefill=isChecked;
                ConfigData.getInstance().SavePZ();
                if(!isChecked) //关闭
                {
                    ExecuteTheRecipe.WritePLC("水池进水阀",false,null);
                }
            }
        });

        save_time.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if(DataIs("延迟时间",edittext_ycsj.getText().toString()))
                {
                    ConfigName.getInstance().AutomaticWaterRefillTime=edittext_ycsj.getText().toString();
                    ConfigData.getInstance().SavePZ();



                    int ftime = 0;
                    try {
                        ftime = (int) Math.round((Double.parseDouble(edittext_ycsj.getText().toString()) * 10));
                    } catch (Exception e) {
                        ToastUtils.error("校准基准时间异常！" + e.getMessage());
                        return;
                    }
                    ExecuteTheRecipe.WritePLC("自动补水延迟时间", (short) ftime, null);
                    ToastUtils.info("保存成功！");
                }
            }
        });
    }

    public boolean DataIs(String name,String data)
    {
        try
        {
            if(data==null || data.isEmpty())
            {
                ToastUtils.error(name+"不能为空！");
                return false;
            }

            Double.parseDouble(data);
            return true;
        }catch (Exception ex)
        {
            ToastUtils.error(name+"数据不合法！");
            return false;
        }
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        Logger.d("我的fragment销毁");
    }

    /**
     * 当在activity设置viewPager + BottomNavigation + fragment时，
     * 为防止viewPager左滑动切换界面，与fragment左滑返回上一界面冲突引起闪退问题，
     * 必须加上此方法，禁止fragment左滑返回上一界面。
     * <p>
     * 切记！切记！切记！否则会闪退！
     * <p>
     * 当在fragment设置viewPager + BottomNavigation + fragment时，则不会出现这个问题。
     */
    @Override
    protected boolean canDragBack() {
        return false;
    }
}